# -*- coding: utf-8 -*-

"""MasterTv
    2013 eseffair"""

import xbmc,xbmcaddon,xbmcgui,xbmcplugin,urllib,urllib2,os,re,sys,datetime,time
from BeautifulSoup import BeautifulSoup


####################################################### CONSTANTES #####################################################

versao = '0.0.2'
addon_id = 'plugin.video.mastertv'
selfAddon = xbmcaddon.Addon(id=addon_id)
addonfolder = selfAddon.getAddonInfo('path')
artfolder = addonfolder + '/resources/img/'


################################################### MENUS PLUGIN ######################################################

def listar_canais(url):
      dialog = xbmcgui.Dialog()
      dialog.ok("Fórum", "Amigos, novo endereço do fórum: forum.freetvbrasil.com, em breve muitas novidades.")
      conteudo = urllib2.urlopen(url).read()
      soup = BeautifulSoup(conteudo)
      for canal in soup.findAll("a",{"target":"kk"}):
            try:
                  addDir(os.path.basename(os.path.splitext(canal['href'])[0]).upper(),canal['href'],2,artfolder+os.path.basename(os.path.splitext(canal.img['src'])[0])+'.png',2,False)
                  print artfolder+os.path.basename(os.path.splitext(canal.img['src'])[0])+'.png'
                  print os.path.splitext(canal['href'])
            except:
                  pass
      xbmc.executebuiltin("Container.SetViewMode(500)")


################################################## PASTAS ################################################################

def addLink(name,url,iconimage):
      liz=xbmcgui.ListItem(name, iconImage="DefaultVideo.png", thumbnailImage=iconimage)
      liz.setInfo( type="Video", infoLabels={ "Title": name } )
      liz.setProperty('fanart_image', "%s/fanart.jpg"%selfAddon.getAddonInfo("path"))
      return xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=url,listitem=liz)

def addDir(name,url,mode,iconimage,total,pasta):
      u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)+"&iconimage"+urllib.quote_plus(str(iconimage))
      print u
      liz=xbmcgui.ListItem(name,iconImage="DefaultFolder.png", thumbnailImage=iconimage)
      liz.setInfo( type="Video", infoLabels={ "Title": name} )
      liz.setProperty('fanart_image', "%s/fanart.jpg"%selfAddon.getAddonInfo("path"))
      return xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=pasta,totalItems=total)

######################################################## OUTRAS FUNCOES ###############################################

def reproduzir(name, icomimage, url):
      print url
      progress = xbmcgui.DialogProgress()
      progress.create("MasterTv", "Capturando stream...")
      conteudo = urllib2.urlopen(url).read()
      soup = BeautifulSoup(conteudo)
      try:
            iframe = soup.findAll('iframe',{'name':"Player"})[0]
            url = iframe['src']
            progress.update(50)
            req = urllib2.Request(url)
            req.add_header('Referer', 'http://tv-msn.com/espnbrasilvip.html')
            req.add_header('Host', 'www.cdnbr.biz')
            req.add_header('Cookie', '__cfduid=df0651fac11b3ed28910193fa94dcb4941400157492241')
            req.add_header('Accept', 'text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,*/*;q=0.8')
            req.add_header('User-Agent', 'Mozilla/5.0 (Windows NT 6.2; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/34.0.1847.116 Safari/537.36')
            conteudo = urllib2.urlopen(req).read()
            playpath = ' playpath=%s' % re.findall(r'file=(.*?)&',conteudo)[0].replace('.flv','')
            rtmp = re.findall(r'streamer=(.*?)&',conteudo)[0]
      except:
            if re.findall(r'<meta http-equiv="refresh" content="1;URL=(.*?)" />',conteudo):
                  url = re.findall(r'<meta http-equiv="refresh" content="1;URL=(.*?)" />',conteudo)[0]
            conteudo = urllib2.urlopen(url).read()
            playpath = ' playpath=%s' % re.findall(r'file=(.*?)&',conteudo)[0].replace('.flv','')
            rtmp = re.findall(r'streamer=(.*?)&',conteudo)[0]
      progress.update(100)
      playlist = xbmc.PlayList(1)
      playlist.clear()
      liz=xbmcgui.ListItem(name, iconImage='DefaultFolder.png', thumbnailImage='DefaultFolder.png')
      liz.setInfo('Video', {'Title':name})
      liz.setProperty('mimetype', 'video')                
      playlist.add(rtmp + playpath, liz)
      xbmcPlayer = xbmc.Player(xbmc.PLAYER_CORE_AUTO)
      xbmcPlayer.play(playlist)

def get_params():
      param=[]
      paramstring=sys.argv[2]
      if len(paramstring)>=2:
            params=sys.argv[2]
            cleanedparams=params.replace('?','')
            if (params[len(params)-1]=='/'):
                  params=params[0:len(params)-2]
            pairsofparams=cleanedparams.split('&')
            param={}
            for i in range(len(pairsofparams)):
                  splitparams={}
                  splitparams=pairsofparams[i].split('=')
                  if (len(splitparams))==2:
                        param[splitparams[0]]=splitparams[1]                 
      return param

params=get_params()
if params:
      print params
url=None
name=None
mode=None
tamanhoparavariavel=None
iconimage=None

try: url=urllib.unquote_plus(params["url"])
except: pass
try: iconimage=urllib.unquote_plus(params["iconimage"])
except: pass
try: tamanhoparavariavel=urllib.unquote_plus(params["tamanhof"])
except: pass
try: name=urllib.unquote_plus(params["name"])
except: pass
try: mode=int(params["mode"])
except: pass

print "Mode: "+str(mode)
print "URL: "+str(url)
print "Name: "+str(name)
print "Name: "+str(tamanhoparavariavel)
print  "Iconimage: "+str(iconimage)

if mode==None or url==None or len(url)<1:
      listar_canais('http://mastertv.biz/index-3.html')
elif mode==1: listar_canais(url)
elif mode==2: reproduzir(name, iconimage, url) #reproduzir_2
elif mode==3: reproduzir_2(name, iconimage, url)
xbmcplugin.endOfDirectory(int(sys.argv[1]))
